/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.dbaneres.file.veriluoc;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 *
 * @author dbaneres
 */
public class XMLCompReader {
    
     //description gate
     public int input;      //gate
                            //fanout splitter
     public int negatein[]; //gate 
                            //bit splitter 
     public int facing;
     public int dimension;
     public int databits;   //all
                            //incoming splitter
                           
     public boolean isoutput;
     public String label;
     public boolean odd_parity;
 
     //plexers
     public boolean istopleft; //tr (topleft), br (by default)  
     public int widthselect;   //plexers, ram,rom,              
     public boolean pinenable; 
        
     //comparator
     public boolean is2complement; //true -> 2C; false -> Unsigned
     
     //shifter / counter //ram //splitter
     public String shiftmode;   //rr, rl, al, lr, ll
                                // counter-> continue, stay, load, wrap (def)
                                // ram -> separate, asynch, synch (def)
                                // splitter -> left (def), right, center, legacy
     
     //counter   //value constant
     public int maxcount;   
     
     //rom
     public String contents; 
     
     
     XMLCompReader ()
     {
         input = -1;
         negatein = null; 
         facing = Location.parsedirection("east");
         dimension = -1;
         databits = -1;
         isoutput = false;
         label = "";
         odd_parity = false;
         
         //plexers
         istopleft = false;
         widthselect = 1;
         pinenable = true;
         
         //comparator
         is2complement = true;
         
         //shifter/counter
         shiftmode = "ll";
         
         //counter
         maxcount = -1;
         
         //rom
         contents = "";
     }
     
     public void ReadAttributes(Element comp)
     {
     

        NodeList listnodes = comp.getChildNodes();

        for(int i=0; i<listnodes.getLength(); i++)
        {
            Node sub = listnodes.item(i); 

            if (sub.getNodeType() == Node.ELEMENT_NODE) {

                Element childNode = (Element)sub;

                String name = childNode.getAttribute("name");

                if (name.equals("inputs")) {
                    input = Integer.parseInt(childNode.getAttribute("val"));
                    negatein = new int[input];  
                }
                else if (name.equals("fanout")) {
                    input = Integer.parseInt(childNode.getAttribute("val"));
                }
                else if (name.equals("facing")) {
                    facing = Location.parsedirection(childNode.getAttribute("val"));
                }
                else if (name.equals("size")) {
                    dimension = Integer.parseInt(childNode.getAttribute("val"));
                }
                else if (name.equals("width")) {
                    databits = Integer.parseInt(childNode.getAttribute("val"));
                }
                else if (name.equals("dataWidth")) { //ram
                    databits = Integer.parseInt(childNode.getAttribute("val"));
                }
                else if (name.equals("incoming")) { //splitter
                    databits = Integer.parseInt(childNode.getAttribute("val"));
                    negatein = new int[databits];  
                    for(int k=0; k<databits; k++)
                       negatein[k] = k;
                }
                else if (name.contains("negate")) {
                    int indexp = Integer.parseInt(name.substring(6)); 
                    negatein[indexp] = 1;
                }
                else if (name.contains("bit")) {
                    int indexp = Integer.parseInt(name.substring(3));
                    int pin = -1;
                    if(!childNode.getAttribute("val").equals("none"))
                      pin = Integer.parseInt(childNode.getAttribute("val"));
                    negatein[indexp] = pin;
                }
                else if (name.contains("xor")) {
                    odd_parity = true; 
                }  
                else if (name.equals("output")) {
                    isoutput = Boolean.parseBoolean(childNode.getAttribute("val"));
                }
                else if (name.equals("label")) {
                    label = childNode.getAttribute("val");
                }
                else if (name.equals("shift")) { //shifter
                    shiftmode = childNode.getAttribute("val");
                }
                else if (name.equals("ongoal")) { //counter
                    shiftmode = childNode.getAttribute("val");
                }
                else if (name.equals("bus")) { //ram
                    shiftmode = childNode.getAttribute("val");
                }
                else if (name.equals("appear")) { //splitter
                    shiftmode = childNode.getAttribute("val");
                }
                else if (name.equals("selloc")) {
                    istopleft = true;
                }
                else if (name.equals("enable")) {
                    pinenable = false;
                }
                else if (name.equals("mode")) {
                    is2complement = false;
                }
                else if (name.equals("select")) {
                    widthselect = Integer.parseInt(childNode.getAttribute("val"));
                }
                else if (name.equals("addrWidth")) { //ram
                    widthselect = Integer.parseInt(childNode.getAttribute("val"));
                }
                else if (name.equals("max")) {
                	/* Added by: erubioman */
                	String val = childNode.getAttribute("val");
                    maxcount = val.length() > 2 ? Integer.parseInt(val.substring(2), 16) : 0;
                	/* Removed by: erubioman
                    maxcount = Integer.parseInt(childNode.getAttribute("val").substring(2),16);
                    */
                }
                else if (name.equals("value")) { //constant
                	/* Added by: erubioman */
                	String val = childNode.getAttribute("val");
                    maxcount = val.length() > 2 ? Integer.parseInt(val.substring(2), 16) : 0;
                	/* Removed by: erubioman
                    maxcount = Integer.parseInt(childNode.getAttribute("val").substring(2),16);
                    */
                }
                else if (name.equals("contents")) { //ram
                    contents = childNode.getTextContent();
                    int pos = contents.indexOf(":");
                    contents =  contents.substring(pos+1).trim();
                }
            }
        } 
     }
     
}
 