package com.erubioman;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.DefaultParser;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;

import com.erubioman.CircParserUi;
import com.erubioman.CircParserConsole;

public class CircParser {

	public static void main(String[] args) {
		Options options = new Options();

		options.addOption("o", "output", true, "fitxer de sortida");
		options.addOption("l", "logisim", false, "és un fitxer Logisim (per defecte = VerilUOC)");
		options.addOption("g", "guess", false, "intenta deduir el tipus de fitxer");

		try {
			// parse the command line arguments
			CommandLineParser parser = new DefaultParser();
			CommandLine line = parser.parse(options, args);
			String outputFile = line.getOptionValue("output");
			int fileType = line.hasOption("guess") ? -1 : line.hasOption("logisim") ? 0 : 1;
			String inputFiles[] = line.getArgs();
			if (inputFiles.length > 0) {
				for (String inputFile : inputFiles) {
					new CircParserConsole().execute(inputFile, outputFile, fileType);
				}
			} else {
				new CircParserUi().execute();
			}
		} catch (ParseException exp) {
			System.out.println("Excepció inesperada:" + exp.getMessage());
		}

	}

}
