package com.erubioman;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import com.dbaneres.file.veriluoc.VerilogXMLWriter;

public class CircParserWrapper implements Loggable {
	
	private Loggable parent;
	
	CircParserWrapper(Loggable _parent) {
		parent = _parent;
	}

	public void addLog(String text) {
		parent.addLog(text);
	}
	
	public void Parse(File inFile, File outFile, int fileType) {
		String fileTypeName = fileType == 0 ? "Logisim" : "VerilUOC";
		addLog("Obrint fitxer CIRC " + fileTypeName + ": " + inFile.getName() + ".\n");
		addLog("Desant fitxer Verilog: " + outFile.getName() + ".\n");
		String result = new String();
		try {
			result = new VerilogXMLWriter().initializeV(inFile, fileType < 0 ? 1 : fileType);
			if (result.contains("error_3_[") && (fileType < 0)) {
				addLog("Format VerilUOC genera error_3. Provant amb format Logisim...\n");
				result = new VerilogXMLWriter().initializeV(inFile, 0);
			}
			if (result.contains("error_3_[")) {
				addLog("ALERTA: error_3 trobat.\n");
			}
		} catch (Exception ex) {
			result = "Parsing error: maybe a wrong CIRC file.\n" + ex.getMessage() + "\n";
			addLog(result);
		}
		try {
			FileWriter writer = new FileWriter(outFile);
			writer.write(result);
			writer.close();
		} catch (IOException ex) {
			addLog("No es pot desar el fitxer " + outFile.getName() + ".\n");
		}
	}
}
