package com.erubioman.verilog.processor;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.DefaultParser;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;

public class ParsedVerilogProcessor {
	
	public static void main(String[] args) {
		Options options = new Options();

		options.addOption("o", "output", true, "nom del fitxer de sortida");
		options.addOption("s", "sort", false, "ordenar dependències entre elements wire");
		options.addOption("w", "wires", false, "simplificar elements wire redundants");
		options.addOption("r", "remove", false, "eliminar elements wire no usats");
		options.addOption("a", "all", false, "realitzar totes les transformacions");

		try {
			// parse the command line arguments
			CommandLineParser parser = new DefaultParser();
			CommandLine line = parser.parse(options, args);
			String outputFile = line.getOptionValue("output");
			boolean doAll = line.hasOption("all");
			boolean doSort = doAll || line.hasOption("sort");
			boolean doWires = doAll || line.hasOption("wires");
			boolean doRemove = doAll || line.hasOption("remove");

			String inputFiles[] = line.getArgs();
			if (inputFiles.length > 0) {
				for (String inputFile : inputFiles) {
					new ParsedVerilogProcessorConsole().Execute(inputFile, outputFile, doSort, doWires, doRemove);
				}
			} else {
				new ParsedVerilogProcessorUi().execute();
			}
		} catch (ParseException exp) {
			System.out.println("Excepció inesperada:" + exp.getMessage());
		}

	}
}
