/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.dbaneres.file.veriluoc;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
/**
 *
 * @author dbaneres
 */
public class VerilogXMLWriter {
    
    private class WriteContext
    {
        File file = null;
        
        // declaration inputs/outputs
        String ini = "";

        //counter of components(adder/register)
        int num_adder = 0;
        int num_reg = 0;
        
        HashSet<String> cables = new HashSet<String>();  //hash wires
        HashSet<Element> splitters= new HashSet<Element>(); //splitters
        HashSet<Element> tunnels= new HashSet<Element>(); //tunnels
        
        //to check connections
        HashMap<String,Integer> mini= new HashMap<String,Integer>();
        HashSet<String> inputsOk = new HashSet<String>();
        HashSet<String> inputsComp = new HashSet<String>();
        
        // check input/outputs labels
        HashSet<String> usednames= new HashSet<String>();
          
        //labels inputs/outputs
        HashMap<String,String> entradas= new HashMap<String,String>();
        HashMap<String,String> salidas= new  HashMap<String,String>();
        
        //labels of tunnels
        HashMap<String, ArrayList> tunnelsbylabel= new HashMap<String,ArrayList>();
        HashMap<String, Element> tunnelsinput= new HashMap<String,Element>();
        
        //document xml
        Document doc;
        
        //check type of component
        int typecomp; 
        
        WriteContext(File file, int typecomp) 
        {
            try {
                this.file = file;
                this.typecomp = typecomp;
                DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
                DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
                doc = dBuilder.parse(file);
                doc.getDocumentElement().normalize();
            } catch (SAXException ex) {
                Logger.getLogger(VerilogXMLWriter.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(VerilogXMLWriter.class.getName()).log(Level.SEVERE, null, ex);
            } catch (ParserConfigurationException ex) {
                Logger.getLogger(VerilogXMLWriter.class.getName()).log(Level.SEVERE, null, ex);
            }
        
        }
        
        WriteContext(String file, int typecomp) 
        {
            try {
            
                this.typecomp = typecomp;
                DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
                DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
                doc = dBuilder.parse(new InputSource(new ByteArrayInputStream(file.getBytes("utf-8"))));
                doc.getDocumentElement().normalize();
            } catch (SAXException ex) {
                Logger.getLogger(VerilogXMLWriter.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(VerilogXMLWriter.class.getName()).log(Level.SEVERE, null, ex);
            } catch (ParserConfigurationException ex) {
                Logger.getLogger(VerilogXMLWriter.class.getName()).log(Level.SEVERE, null, ex);
            }
        
        }
        
         
        String fromVerilogFile()
        {
                String xurro;
                if(file == null)
                    xurro= "module " + "tempmodule" + "(&ENTRADAS&&SALIDAS&);"+"\n"+"&INICI&";
                else
                    xurro= "module "+ file.getName()+"(&ENTRADAS&&SALIDAS&);"+"\n"+"&INICI&";
                
                // System.out.println ("Root element of the doc is " + 
                // doc.getDocumentElement().getNodeName());
                
                NodeList nodetop = doc.getElementsByTagName("circuit");      
                NodeList listnodes= nodetop.item(0).getChildNodes();
                
                
                for(int i=0; i<listnodes.getLength(); i++)
                {
                   Node sub = listnodes.item(i); 
                   
                   if (sub.getNodeType() == Node.ELEMENT_NODE) {
                       Element childNode = (Element)sub;
                
                        String vercirc=fromCircuitV(childNode);
                        if(!vercirc.startsWith("error"))
                            xurro += vercirc;
                        else
                            return vercirc;
                   }
                }
                
                //process tunnels
                String tempo =  process_tunnels();
                if(tempo.startsWith("error"))                   
                    return tempo;
                
                //connect remaining wires with splitters
               while(mini.size() > 0)
               {
                    Iterator it = mini.keySet().iterator();
                    for(;it.hasNext();)//para cada salida
                    {
                        String punto=(String)it.next();
                        //System.out.println("mini: "+punto);
                        Iterator cab = cables.iterator();

                        for(;cab.hasNext();)//para cada cable
                        {
                            String cable= (String)cab.next();
                            //System.out.println("cable: "+cable);
                            String[] list= cable.split("/");
                            if(punto.startsWith(list[0]) && (list[2].matches("undefined") || list[2].matches("derecha")))
                            {
                                Integer num= mini.get(punto);
                                for(int p=0;p<num;p++)
                                  //xurro += VerilogComponents.comp_WIRE(list[1], p, list[0], p); 
                                {
                                    xurro += "assign "+list[1]+p+" = "+list[0]+p+";\n";
                                    if(!ini.contains(list[1]+p))
                                        xurro+="wire " +   list[1]+p + ";\n";
                                }
                                mini.put(list[1], num);
                                inputsOk.add(list[1]);
                                cables.remove(cable);
                                cab= cables.iterator();
                            }
                            if(punto.startsWith(list[1]) && (list[2].matches("undefined") || list[2].matches("izquierda")))
                            {
                                Integer num= mini.get(punto);
                                for(int p=0;p<num;p++)
                                {
                                    xurro += "assign "+list[0]+p+" = "+list[1]+p+";\n";
                                    if(!ini.contains(list[0]+p))
                                        xurro+="wire " +   list[0]+p + ";\n";
                                }
                                mini.put(list[0], num);
                                inputsOk.add(list[0]);
                                cables.remove(cable);
                                cab= cables.iterator();
                            }
                        }//fin cada cable

                        Iterator ite= splitters.iterator();
                        for(;ite.hasNext();)//Para cada splitter
                        {
                            Element spl= (Element)ite.next();
                            
                            String posin = splitter_get_input(spl);
                            if(punto.matches(posin))
                            //String spl= (String)ite.next();
                            //String[] list= spl.split("/");
                            //if(punto.matches(list[0]))
                            {
                                xurro+=comp_Splitter(spl,true);
                                splitters.remove(spl);
                                ite= splitters.iterator();
                               
                            }
                            else
                            {
                                String posout = splitter_get_output(spl);
                                if(posout.contains(punto))
                                {
                                    xurro+= comp_Splitter(spl, false);
                                    splitters.remove(spl);
                                    ite= splitters.iterator();
                                }
                            }
                        }
                        
                        //connect tunnels
                        ite= tunnels.iterator();
                        for(;ite.hasNext();)//Para cada splitter
                        {
                            Element spl= (Element)ite.next();
                            
                            String posin = splitter_get_input(spl);
                            if(punto.matches(posin))
                            {
                                tempo=comp_Tunnel(spl);
                                if(tempo.startsWith("error"))                   
                                  return tempo;   
                                xurro += tempo; 
                                //tunnels are removed inside function
                                //tunnels.remove(spl);
                                ite= tunnels.iterator();
                            }
                        }
                       /* Iterator itee= splitters.iterator();
                        for(;itee.hasNext();)//Para cada splitter de nuevo
                        {
                            String spl= (String)itee.next();
                            String[] listaou= fun_splitter(spl,1).split("/");
                            HashSet<String> ous = new HashSet<String>();
                            ous.addAll(Arrays.asList(listaou));
                            
                                                   
                            if(ous.contains(punto))
                            {
                                xurro+= fun_splitter(spl, 2);
                                splitters.remove(spl);
                                itee= splitters.iterator();
                            }
                        }*/
                        mini.remove(punto);
                        it = mini.keySet().iterator();
                    }
                }

                inputsComp.removeAll(inputsOk);

                if(inputsComp.size() > 0)
                    xurro= "error_3_" + inputsComp.toString()  + "\n"+xurro;//Hi ha components sense entrada

                //System.out.println("FIN");

                String ent="";
                String sor="";
                int c=0,c2=0;

                ArrayList<String> valuesentrada = new ArrayList<String>(entradas.keySet());
                Collections.sort(valuesentrada);

                Iterator stepper = valuesentrada.iterator();
                while (stepper.hasNext()) {
                    String current = (String)stepper.next();

                    if(c!=0)
                       ent+= ", "+current;
                    else
                       ent+= current;
                    c++;
                }

                ArrayList<String> valuessortida = new ArrayList<String>(salidas.keySet());
                Collections.sort(valuessortida);

                Iterator stepper2 = valuessortida.iterator();
                while (stepper2.hasNext()) {
                    String current = (String)stepper2.next();
                    //System.out.println("---"+current);

                    if(c2!=0)
                       sor+= ", "+current;
                    else
                       sor+= current;
                    c2++;
                }

                if(sor.matches(""))
                {
                    xurro = "error_2";//No hi ha outputs.
                }
                else
                {
                    xurro=xurro.replaceFirst("&ENTRADAS&", ent);
                    if(ent.length() > 0 && sor.length() > 0)
                        sor=","+sor;
                    xurro=xurro.replaceFirst("&SALIDAS&", sor);
                    xurro=xurro.replaceFirst("&INICI&", ini);
                    xurro+="endmodule";
                }
                return xurro;
                
        
        }
        
        String fromCircuitV(Element sub_elt)
        {
            String xurro = "";
            
            String sub_elt_name = sub_elt.getTagName();
            if (sub_elt_name.equals("comp")) {
                xurro = process_comp(sub_elt); 
            } else if (sub_elt_name.equals("wire")) {
                process_wire(sub_elt);    
            }
            
            return xurro;
        }

        //process a single wire
        void process_wire(Element wire)
        {
            Location from = Location.parse(wire.getAttribute("from"));
            Location to = Location.parse(wire.getAttribute("to"));
            
            cables.add(from.toverilog() +"/"+ to.toverilog()+"/undefined");
            
        /*    String from = wire.getAttribute("from");
            String to = wire.getAttribute("to");
            
            cables.add(parse(from)+"/"+parse(to)+"/undefined");*/
        }   
        
        String process_comp(Element comp)
        {
            String xurro = "";
            
            String tipus = comp.getAttribute("name");
            String location = comp.getAttribute("loc");
            
            XMLCompReader compattr = new XMLCompReader();
            
            Location posout = Location.parse(location);
         
            
          
            if(tipus.matches("AND Gate") || tipus.matches("NAND Gate") || tipus.matches("OR Gate")
                || tipus.matches("NOR Gate") || tipus.matches("XOR Gate") || tipus.matches("XNOR Gate"))
            
                xurro += comp_Gate(comp, tipus, posout, compattr);
            
            else if(tipus.matches("Pin"))
            
                xurro += comp_Pin(comp, tipus, posout, compattr);
            
            else if(tipus.matches("Button"))
                xurro += comp_Button(comp, posout, compattr);
            
            else if(tipus.matches("Clock"))
                xurro += comp_Clock(comp, posout, compattr);
            
            else if(tipus.matches("LED"))
                xurro += comp_LED(comp, posout, compattr);
            
            //Final Pin
            else if(tipus.matches("NOT Gate"))
            
                 xurro += comp_Not(comp, posout, compattr);
            //Final Not
            else if(tipus.matches("Buffer"))
            
                xurro += comp_Buffer(comp, posout, compattr);
            
            else if(tipus.matches("Multiplexer"))
                xurro += comp_Mux(comp, posout, compattr);
              
            else if(tipus.matches("Demultiplexer"))
                xurro += comp_Demux(comp, posout, compattr);
            
            else if(tipus.matches("Decoder"))
                xurro += comp_Decoder(comp, posout, compattr);
            
            else if(tipus.matches("Priority Encoder"))
                xurro += comp_Encoder(comp, posout, compattr);
            
            else if(tipus.matches("Adder"))
                xurro += comp_Adder(comp, posout, compattr);
            
            else if(tipus.matches("Negator"))
                xurro += comp_Negator(comp, posout, compattr);
            
            else if(tipus.matches("Comparator"))
                xurro += comp_Comparator(comp, posout, compattr);
            
            else if(tipus.matches("Shifter"))
                xurro += comp_Shifter(comp, posout, compattr);
            
            else if(tipus.matches("D Flip-Flop"))
                xurro += comp_DFlipFlop(comp, posout, compattr);
            
            else if(tipus.matches("Register"))
                xurro += comp_Register(comp, posout, compattr);
            
            else if(tipus.matches("Counter"))
                xurro += comp_Counter(comp, posout, compattr);
            
            else if(tipus.matches("RAM"))
                xurro += comp_RAM(comp, posout, compattr);
            
            else if(tipus.matches("ROM"))
                xurro += comp_ROM(comp, posout, compattr);
            
            else if(tipus.matches("Splitter"))
                splitters.add(comp);
                
            else if(tipus.matches("Tunnel"))
                tunnels.add(comp);
                
            else if(tipus.matches("Constant"))
                xurro += comp_Constant(comp, posout, compattr);
            
             
            return xurro;
        }
        
        private String comp_Gate(Element comp, String tipus, Location posout, XMLCompReader compattr)
        {
            ArrayList<Location> posin; 
            String xurro = "";

            compattr.input = 5;
            compattr.negatein = new int[compattr.input];
            compattr.dimension = 50;
            compattr.databits = 1;
            compattr.ReadAttributes(comp);

            /* <a name="inputs" val="6"/>
            <a name="facing" val="north"/>
            <a name="size" val="30"/>
            <a name="negate0" val="true"/>
            <a name="negate1" val="true"/>
            <a name="negate2" val="true"/>
            <a name="negate3" val="true"/>
            <a name="negate4" val="true"/> 
            <a name="width" val="2"/> */

            int offset = 0;  
            //adjust gates    
            if(tipus.matches("XOR Gate") || tipus.matches("NOR Gate") || tipus.matches("NAND Gate") )
                offset = -10;
            else if(tipus.matches("XNOR Gate"))
                offset = -20;

            posin = new ArrayList<Location>();  

            if(compattr.input == 2)
            {
                if(compattr.dimension == 30) // small
                {
                    posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension + offset, -10, compattr.negatein[0]));
                    posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension + offset, 10, compattr.negatein[1]));
                }
                else
                {
                    posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension + offset, -20, compattr.negatein[0]));
                    posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension + offset, 20, compattr.negatein[1]));
                }
                inputsComp.add(posin.get(0).toverilog());
                inputsComp.add(posin.get(1).toverilog());
            }
            else if(compattr.input == 3 )
            {
                if(compattr.dimension == 30) //small
                {
                    posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension + offset, -10, compattr.negatein[0]));
                    posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension + offset, 0, compattr.negatein[1]));
                    posin.add(2, posout.movepoint(compattr.facing, -compattr.dimension + offset, 10, compattr.negatein[2]));
                }
                else if(compattr.dimension == 50) //medium
                {
                    posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension + offset, -20, compattr.negatein[0]));
                    posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension + offset, 0, compattr.negatein[1]));
                    posin.add(2, posout.movepoint(compattr.facing, -compattr.dimension + offset, 20, compattr.negatein[2]));
                }
                else // wide
                {
                    posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension + offset, -30, compattr.negatein[0]));
                    posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension + offset, 0, compattr.negatein[1]));
                    posin.add(2, posout.movepoint(compattr.facing, -compattr.dimension + offset, 30, compattr.negatein[2]));
                }
                inputsComp.add(posin.get(0).toverilog());
                inputsComp.add(posin.get(1).toverilog());
                inputsComp.add(posin.get(2).toverilog());
            }
            else if(compattr.input == 4 )
            {
                if(compattr.dimension == 70) //wide
                {
                   /* if(compattr.facing == Location.SOUTH || compattr.facing == Location.WEST)
                    {
                    int k = 0;
                    for(int i = -4; i<=2; i+=2)
                    {
                        posin.add(k, posout.movepoint(compattr.facing, -compattr.dimension + offset, i*10));
                        k++;
                    }
                    }
                    else*/
                    {
                        int k = 0;
                        for(int i = -2; i<=4; i+=2)
                        {
                            posin.add(k, posout.movepoint(compattr.facing, -compattr.dimension + offset, i*10, compattr.negatein[k]));
                            k++;
                        }
                    }
                }
                else
                {
                    int k = 0;
                    int ini = compattr.input/2;
                    for(int i = -ini; i<0; i++)
                    {
                        posin.add(k, posout.movepoint(compattr.facing, -compattr.dimension + offset, i*10, compattr.negatein[k]));
                        k++;
                    }
                    for(int i = 1; i<=compattr.input/2; i++)
                    {
                        posin.add(k, posout.movepoint(compattr.facing, -compattr.dimension + offset, i*10, compattr.negatein[k]));
                        k++;
                    }
                }    
                inputsComp.add(posin.get(0).toverilog());
                inputsComp.add(posin.get(1).toverilog());
                inputsComp.add(posin.get(2).toverilog());
                inputsComp.add(posin.get(3).toverilog());

            }
            else // compattr.input > 3
            {
                if(compattr.input%2 == 0)
                {
                    int k = 0;
                    int ini = compattr.input/2;
                    for(int i = -ini; i<0; i++)
                    {
                        posin.add(k, posout.movepoint(compattr.facing, -compattr.dimension + offset, i*10, compattr.negatein[k]));
                        inputsComp.add(posin.get(k).toverilog());
                        k++;
                    }
                    for(int i = 1; i<=compattr.input/2; i++)
                    {
                        posin.add(k, posout.movepoint(compattr.facing, -compattr.dimension + offset, i*10, compattr.negatein[k]));
                        inputsComp.add(posin.get(k).toverilog());
                        k++;
                    }
                }
                else
                {
                    int k = 0;
                    int ini = compattr.input/2;
                    for(int i = -ini; i<=compattr.input/2; i++)
                    {
                        posin.add(k, posout.movepoint(compattr.facing, -compattr.dimension + offset, i*10, compattr.negatein[k]));
                        inputsComp.add(posin.get(k).toverilog());
                        k++;
                    }
                }
            }

            if(tipus.equals("XNOR Gate"))
                xurro += VerilogComponents.comp_XOR_XNOR(tipus, posin, posout, compattr.negatein, compattr.input, compattr.databits, compattr.odd_parity, false);
            else if(tipus.equals("XOR Gate"))
                xurro += VerilogComponents.comp_XOR_XNOR(tipus, posin, posout, compattr.negatein, compattr.input, compattr.databits, compattr.odd_parity, true);
            else
                xurro += VerilogComponents.comp_GATE(tipus, posin, posout, compattr.negatein, compattr.input, compattr.databits);

            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());
            
            return xurro;
        }
        
        private String comp_Pin(Element comp, String tipus, Location posout, XMLCompReader compattr)
        {
            
            //ArrayList<Location> posin; 
            String xurro = "";
       
            compattr.databits = 1;
            
            compattr.ReadAttributes(comp);              
            
            
            /*
            <a name="facing" val="north"/>
                <a name="output" val="true"/>
                <a name="width" val="2"/>
                <a name="tristate" val="false"/>
                <a name="compattr.label" val="ee"/>
                */
          
            

            if(compattr.isoutput == true)//OUTPUT
            {
                if(compattr.label.matches(""))
                    return "error_1_Output_" + posout.toString();//No compattr.label

                if(!VerilogComponents.isValidLabel(compattr.label))
                  return "error_6_" + compattr.label;
                
                for(int p=0;p<compattr.databits;p++)
                {
                    String label2=compattr.label+"_"+p;

                    if(!usednames.contains(label2))
                    {
                        salidas.put(label2, posout.toverilog(p));
                        usednames.add(label2);
                    }
                    else
                        return "error_4_"+label2;

                }

                ini += VerilogComponents.def_OUTPUT(posout, compattr.label, compattr.databits);
                xurro += VerilogComponents.comp_OUTPUT(posout, compattr.label, compattr.databits);

                inputsComp.add(posout.toverilog());
            }
            else //INPUT
            {
                if(compattr.label.matches(""))
                    return "error_1_Input_" + posout.toString(); //No hi ha compattr.label

                if(!VerilogComponents.isValidLabel(compattr.label))
                  return "error_6_" + compattr.label;
                
                for(int p=0;p<compattr.databits;p++)
                {
                    String label2=compattr.label+"_"+p;

                    if(!usednames.contains(label2))
                    {
                        entradas.put(label2, posout.toverilog(p));
                        usednames.add(label2);
                    }
                    else
                        return "error_4_"+label2;

                }

                ini += VerilogComponents.def_INPUT(posout, compattr.label, compattr.databits);
                xurro += VerilogComponents.comp_INPUT(posout, compattr.label, compattr.databits);

                mini.put(posout.toverilog(), compattr.databits);
                inputsOk.add(posout.toverilog());
            }

            return xurro;
        }
        
        private String comp_LED(Element comp, Location posout, XMLCompReader compattr)
        {
            
            //ArrayList<Location> posin; 
            String xurro = "";
       
            compattr.databits = 1;
            
            compattr.ReadAttributes(comp);              
            
            
            /*
            <a name="facing" val="north"/>
                <a name="compattr.label" val="ee"/>
                */


           
            if(compattr.label.matches(""))
                return "error_1_Output_" + posout.toString();//No compattr.label

            for(int p=0;p<compattr.databits;p++)
            {
                String label2=compattr.label+"_"+p;

                if(!usednames.contains(label2))
                {
                    salidas.put(label2, posout.toverilog(p));
                    usednames.add(label2);
                }
                else
                    return "error_4_"+label2;

            }

            ini += VerilogComponents.def_OUTPUT(posout, compattr.label, compattr.databits);
            xurro += VerilogComponents.comp_OUTPUT(posout, compattr.label, compattr.databits);

            inputsComp.add(posout.toverilog());
         

            return xurro;
        }
        
         private String comp_Button(Element comp, Location posout, XMLCompReader compattr)
        {
            
            //ArrayList<Location> posin; 
            String xurro = "";
       
            compattr.databits = 1;
            
            compattr.ReadAttributes(comp);              
            
            
            /*
            <a name="facing" val="north"/>
                <a name="compattr.label" val="ee"/>
                */

            if(compattr.label.matches(""))
                return "error_1_Input_" + posout.toString(); //No hi ha compattr.label


            for(int p=0;p<compattr.databits;p++)
            {
                String label2=compattr.label+"_"+p;

                if(!usednames.contains(label2))
                {
                    entradas.put(label2, posout.toverilog(p));
                    usednames.add(label2);
                }
                else
                    return "error_4_"+label2;

            }

            ini += VerilogComponents.def_INPUT(posout, compattr.label, compattr.databits);
            xurro += VerilogComponents.comp_INPUT(posout, compattr.label, compattr.databits);

            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());


            return xurro;
        }
         
         
        private String comp_Clock(Element comp, Location posout, XMLCompReader compattr)
        {
            
            //ArrayList<Location> posin; 
            String xurro = "";
       
            compattr.databits = 1;
            
            compattr.ReadAttributes(comp);              
            
            
            /*
            <a name="facing" val="north"/>
                <a name="compattr.label" val="ee"/>
                */

            if(compattr.label.matches(""))
                //return "error_1_Input_" + posout.toString(); //No hi ha compattr.label
                compattr.label = "clk";

            for(int p=0;p<compattr.databits;p++)
            {
                String label2=compattr.label+"_"+p;

                if(!usednames.contains(label2))
                {
                    entradas.put(label2, posout.toverilog(p));
                    usednames.add(label2);
                }
                else
                    return "error_4_"+label2;

            }

            ini += VerilogComponents.def_INPUT(posout, compattr.label, compattr.databits);
            xurro += VerilogComponents.comp_INPUT(posout, compattr.label, compattr.databits);

            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());


            return xurro;
        } 
        
        private String comp_Not(Element comp, Location posout, XMLCompReader compattr)
        {
            
            ArrayList<Location> posin; 
            String xurro = "";
            compattr.databits = 1;
           
            compattr.dimension = 30;
                
            compattr.ReadAttributes(comp);              

            /* <a name="size" val="20"/>
                <a name="facing" val="north"/>
                <a name="width" val="2"/>
            */

            posin = new ArrayList<Location>();  

            posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension, 0));

            xurro += VerilogComponents.comp_NOT(posin.get(0), posout, compattr.databits);

            inputsComp.add(posin.get(0).toverilog());
            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());
            
            return xurro;
        }
        
        private String comp_Constant(Element comp, Location posout, XMLCompReader compattr)
        {
            
            
            String xurro = "";
            compattr.databits = 1;
            compattr.maxcount = 1;
    
                
            compattr.ReadAttributes(comp);              

            /*   <a name="facing" val="north"/>
                <a name="width" val="7"/>
                <a name="value" val="0x7f"/>
            */

          

            xurro += VerilogComponents.comp_CONSTANT( posout, compattr.databits, compattr.maxcount);

         
            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());
            
            return xurro;
        }
        
        private String comp_Buffer(Element comp, Location posout, XMLCompReader compattr)
        {
            
            ArrayList<Location> posin; 
            String xurro = "";
            
            compattr.databits = 1;
            compattr.dimension = 20;

            compattr.ReadAttributes(comp);              

            /* <a name="size" val="20"/>
                <a name="facing" val="north"/>
                <a name="width" val="2"/>
            */

            posin = new ArrayList<Location>();  

            posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension, 0));

            xurro += VerilogComponents.comp_BUFFER(posin.get(0), posout, compattr.databits);

            inputsComp.add(posin.get(0).toverilog());
            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());

            return xurro;
        }
        
        private String comp_Mux(Element comp, Location posout, XMLCompReader compattr)
        {
            Location possel, posenable;
            
            ArrayList<Location> posin; 
            String xurro = "";
            
            compattr.databits = 1;
            compattr.dimension = 20;

            compattr.ReadAttributes(comp); 
            
            /*
            <a name="facing" val="north"/>
                <a name="selloc" val="tr"/>
                <a name="select" val="2"/>
                <a name="width" val="2"/>
                <a name="enable" val="false"/>
            */
            
            posin = new ArrayList<Location>();  
            
               if(compattr.widthselect == 1)
              compattr.dimension = 30;
            else
              compattr.dimension = 40;
            
            if(compattr.widthselect == 1)
            {
                posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension, -10));
                posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension ,10));
            
                inputsComp.add(posin.get(0).toverilog());
                inputsComp.add(posin.get(1).toverilog());
                
                if(compattr.istopleft == false) //bottom
                {
                    possel =  posout.movepointz(compattr.facing, -20, 20);
                    posenable = posout.movepointz(compattr.facing, -10, 20);
                }
                else
                {
                    possel =  posout.movepointz(compattr.facing, -20, -20);
                    posenable = posout.movepointz(compattr.facing, -10, -20);
                }
            }
            else
            {
                int offset = (int)Math.pow(2, compattr.widthselect -1);
               
                if(compattr.istopleft == false) //bottom
                {
                    possel =  posout.movepointz(compattr.facing, -20, offset * 10);
                    posenable = posout.movepointz(compattr.facing, -10, offset * 10);
                }
                else
                {
                    possel =  posout.movepointz(compattr.facing, -20, -offset * 10);
                    posenable = posout.movepointz(compattr.facing, -10, -offset * 10);
                }
                
                int count = (int)Math.pow(2, compattr.widthselect);
                for(int i = 0; i < count; i++)
                {
                    posin.add(i, posout.movepoint(compattr.facing, -compattr.dimension, -offset*10));
                    inputsComp.add(posin.get(i).toverilog());
                    offset--;
                }
                   
            }
            
            xurro += VerilogComponents.comp_MUX(posin, possel, posenable, posout, compattr.widthselect,  compattr.databits, compattr.pinenable);
            
            inputsComp.add(possel.toverilog());
            if(compattr.pinenable == true)
               inputsComp.add(posenable.toverilog()); 
            
            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());
            
            
            return xurro;
           
        }
        
        private String comp_Demux(Element comp, Location posin, XMLCompReader compattr)
        {
            Location possel, posenable;
            
            ArrayList<Location> posout; 
            String xurro = "";
            
            compattr.databits = 1;
            compattr.dimension = 20;

            compattr.ReadAttributes(comp); 
            
            /*
            <a name="facing" val="north"/>
                <a name="selloc" val="tr"/>
                <a name="select" val="2"/>
                <a name="width" val="2"/>
                <a name="enable" val="false"/>
            */
            
            posout = new ArrayList<Location>();  
            
            if(compattr.widthselect == 1)
              compattr.dimension = 30;
            else
              compattr.dimension = 40;
            
            if(compattr.widthselect == 1)
            {
                posout.add(0, posin.movepoint(compattr.facing, compattr.dimension, -10));
                posout.add(1, posin.movepoint(compattr.facing, compattr.dimension ,10));
               
                mini.put(posout.get(0).toverilog(), compattr.databits);
                inputsOk.add(posout.get(0).toverilog());
                mini.put(posout.get(1).toverilog(), compattr.databits);
                inputsOk.add(posout.get(1).toverilog());
                
                if(compattr.istopleft == false) //bottom
                {
                    possel =  posin.movepointz(compattr.facing, 20, 20);
                    posenable = posin.movepointz(compattr.facing, 10, 20);
                }
                else
                {
                    possel =  posin.movepointz(compattr.facing, 20, -20);
                    posenable = posin.movepointz(compattr.facing, 10, -20);
                }
            }
            else
            {
                int offset = (int)Math.pow(2, compattr.widthselect -1);
               
                if(compattr.istopleft == false) //bottom
                {
                    possel =  posin.movepointz(compattr.facing, 20, offset * 10);
                    posenable = posin.movepointz(compattr.facing, 10, offset * 10);
                }
                else
                {
                    possel =  posin.movepointz(compattr.facing, 20, -offset * 10);
                    posenable = posin.movepointz(compattr.facing, 10, -offset * 10);
                }
                
                int count = (int)Math.pow(2, compattr.widthselect);
                for(int i = 0; i < count; i++)
                {
                    posout.add(i, posin.movepoint(compattr.facing, compattr.dimension, -offset*10));
                    mini.put(posout.get(i).toverilog(), compattr.databits);
                    inputsOk.add(posout.get(i).toverilog());
                    offset--;
                }
                   
            }
            
            xurro += VerilogComponents.comp_DEMUX(posin, possel, posenable, posout, compattr.widthselect,  compattr.databits, compattr.pinenable);
            
            inputsComp.add(possel.toverilog());
            if(compattr.pinenable == true)
               inputsComp.add(posenable.toverilog()); 
            
            inputsComp.add(posin.toverilog());           
            
            return xurro;
           
        }
        
        private String comp_Decoder(Element comp, Location possel, XMLCompReader compattr)
        {
            Location posin, posenable;
            
            ArrayList<Location> posout; 
            String xurro = "";
            
            compattr.databits = 1;
            compattr.dimension = 20;

            compattr.ReadAttributes(comp); 
            
            /*
            <a name="facing" val="north"/>
                <a name="selloc" val="tr"/>
                <a name="select" val="2"/>
                <a name="enable" val="false"/>
            */
            
            //equal to demux but posin = offset(20,20) from possel
            if(compattr.widthselect == 1)
            {
              if(compattr.istopleft == false) //bottom
                posin =  possel.movepointz(compattr.facing, -20, -20); 
              else
                posin =  possel.movepointz(compattr.facing, -20, 20);
                  
            }
            else
            {
                int offset = (int)Math.pow(2, compattr.widthselect -1);
               
                if(compattr.istopleft == false) //bottom
                    posin =  possel.movepointz(compattr.facing, -20, -offset * 10);
                else
                    posin =  possel.movepointz(compattr.facing, -20, offset * 10);

            }
            
            posout = new ArrayList<Location>();  
            
            if(compattr.widthselect == 1)
              compattr.dimension = 30;
            else
              compattr.dimension = 40;
            
            if(compattr.widthselect == 1)
            {
                posout.add(0, posin.movepoint(compattr.facing, compattr.dimension, -10));
                posout.add(1, posin.movepoint(compattr.facing, compattr.dimension ,10));
               
                mini.put(posout.get(0).toverilog(), compattr.databits);
                inputsOk.add(posout.get(0).toverilog());
                mini.put(posout.get(1).toverilog(), compattr.databits);
                inputsOk.add(posout.get(1).toverilog());
                
                if(compattr.istopleft == false) //bottom
                {
                  
                    posenable = posin.movepointz(compattr.facing, 10, 20);
                }
                else
                {
                 
                    posenable = posin.movepointz(compattr.facing, 10, -20);
                }
            }
            else
            {
                int offset = (int)Math.pow(2, compattr.widthselect -1);
               
                if(compattr.istopleft == false) //bottom
                {
                    possel =  posin.movepointz(compattr.facing, 20, offset * 10);
                    posenable = posin.movepointz(compattr.facing, 10, offset * 10);
                }
                else
                {
                    possel =  posin.movepointz(compattr.facing, 20, -offset * 10);
                    posenable = posin.movepointz(compattr.facing, 10, -offset * 10);
                }
                
                int count = (int)Math.pow(2, compattr.widthselect);
                for(int i = 0; i < count; i++)
                {
                    posout.add(i, posin.movepoint(compattr.facing, compattr.dimension, -offset*10));
                    mini.put(posout.get(i).toverilog(), compattr.databits);
                    inputsOk.add(posout.get(i).toverilog());
                    offset--;
                }
                   
            }
            
            
            xurro += VerilogComponents.comp_DECODER(possel, posenable, posout, compattr.widthselect,  compattr.pinenable);
            
            inputsComp.add(possel.toverilog());
            if(compattr.pinenable == true)
               inputsComp.add(posenable.toverilog()); 
            
            return xurro;
           
        }
        
        private String comp_Encoder(Element comp, Location posout, XMLCompReader compattr)
        {
            Location posenableout, posenable, posgroupselect;
            
            ArrayList<Location> posin; 
            String xurro = "";
            
            compattr.databits = 1;
            compattr.dimension = 40;
            compattr.widthselect = 3;
            
            compattr.ReadAttributes(comp); 
            
            /*
            <a name="facing" val="north"/>      
                <a name="select" val="2"/>    
                * 
                *  
                * 
            */
            
            posin = new ArrayList<Location>();  
            
            posgroupselect =  posout.movepoint(compattr.facing, 0, 10);
       
            if(compattr.widthselect == 1)
            {
                posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension, 0));
                posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension ,10)); 
                
                posenable = posout.movepoint(compattr.facing, -20, 20);
                posenableout = posout.movepoint(compattr.facing, -20, -10);
                
                inputsComp.add(posin.get(0).toverilog());
                inputsComp.add(posin.get(1).toverilog());
                
              
            }
            else
            {
                //it is the same position than mux + 10
                int offset = (int)Math.pow(2, compattr.widthselect -1) - 1;
               
                posenable = posout.movepoint(compattr.facing, -20, (offset + 2) * 10);
                posenableout =  posout.movepoint(compattr.facing, -20, -(offset + 1) * 10);
                      
                int count = (int)Math.pow(2, compattr.widthselect);
                for(int i = 0; i < count; i++)
                {
                    posin.add(i, posout.movepoint(compattr.facing, -compattr.dimension, -offset*10));
                    inputsComp.add(posin.get(i).toverilog());
                    offset--;
                }
                   
            }
            
            xurro += VerilogComponents.comp_ENCODER(posin, posenable, posout, posgroupselect,  posenableout, compattr.widthselect);
            
         
            inputsComp.add(posenable.toverilog()); 
               
            mini.put(posout.toverilog(), compattr.widthselect);
            inputsOk.add(posout.toverilog());
            mini.put(posgroupselect.toverilog(), 1);
            inputsOk.add(posgroupselect.toverilog());
            mini.put(posenableout.toverilog(), 1);
            inputsOk.add(posenableout.toverilog());
            
             
            
            
            return xurro;
           
        }
        
        
        private String comp_Adder(Element comp, Location posout, XMLCompReader compattr)
        {
        
            Location poscin, poscout;
            
            ArrayList<Location> posin; 
            String xurro = "";
            
            compattr.databits = 8;
            if(typecomp == 0)
                compattr.dimension = 40;
            else
                compattr.dimension = 60;

            compattr.ReadAttributes(comp); 
            
            /*
            <a name="width" val="2"/> 
            */
        
            posin = new ArrayList<Location>();  
            
            if(typecomp == 0)
            {
                posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension, -10));
                posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension, 10));

                poscin = posout.movepoint(compattr.facing, -20, -20);
                poscout = posout.movepoint(compattr.facing, -20, 20);
            }
            else
            {
                compattr.facing = Location.parsedirection("south");
                posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension, -20));
                posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension, 20));

                poscin = posout.movepoint(compattr.facing,  -30,  40);
                poscout = posout.movepoint(compattr.facing, -30, -40);
            }
            
            xurro += VerilogComponents.comp_ADDER(posin, posout, poscin, poscout, compattr.databits);
            
            
            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());

            mini.put(poscout.toverilog(), 1);
            inputsOk.add(poscout.toverilog());
            inputsComp.add(poscin.toverilog());
            inputsComp.add(posin.get(0).toverilog());
            inputsComp.add(posin.get(1).toverilog());
            
            
            return xurro;
        }//Final Adder
 
        private String comp_Negator(Element comp, Location posout, XMLCompReader compattr)
        {
          
            Location posin; 
            String xurro = "";
            
            compattr.databits = 8;
            if(typecomp == 0)
               compattr.dimension = 40;
            else
               compattr.dimension = 60;
            
            compattr.ReadAttributes(comp); 
            
            /*
            <a name="width" val="2"/> 
            */
            
            if(typecomp == 0)
                posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
            else
            {
                compattr.facing = Location.parsedirection("south");
                posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
            }
            
            xurro += VerilogComponents.comp_NEGATOR(posin, posout, compattr.databits);
       
                
            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());
            inputsComp.add(posin.toverilog());
            
            return xurro;
        }
        
       private String comp_Comparator(Element comp, Location posequal, XMLCompReader compattr)
        { 
            
            Location posless, posgreater;
            
            ArrayList<Location> posin; 
            String xurro = "";
            
            compattr.databits = 8;
            if(typecomp == 0)
                compattr.dimension = 40;
            else
                compattr.dimension = 60;
            
            compattr.ReadAttributes(comp); 
            
            /*
                <a name="width" val="9"/>
                <a name="mode" val="unsigned"/>
            */
        
            posin = new ArrayList<Location>();  
            
            if(typecomp == 0)
            {
                posin.add(0, posequal.movepoint(compattr.facing, -compattr.dimension, -10));
                posin.add(1, posequal.movepoint(compattr.facing, -compattr.dimension, 10));

                posless = posequal.movepoint(compattr.facing,  0, 10);
                posgreater = posequal.movepoint(compattr.facing, 0, -10);
            }
            else
            {
                compattr.facing = Location.parsedirection("south");
                posin.add(0, posequal.movepoint(compattr.facing, -compattr.dimension, -20));
                posin.add(1, posequal.movepoint(compattr.facing, -compattr.dimension, 20));

                posless = posequal.movepoint(compattr.facing,  0, 20);
                posgreater = posequal.movepoint(compattr.facing, 0, -20);
            }
            
            compattr.is2complement = false; /* Added by: erubioman */
            if(compattr.is2complement == true)
                xurro += "error_5_mode_comparator";
            else
                xurro += VerilogComponents.comp_COMPARATOR(posin, posless, posequal, posgreater, compattr.databits, compattr.is2complement);
           
            
            mini.put(posequal.toverilog(), 1);
            inputsOk.add(posequal.toverilog());
            mini.put(posless.toverilog(), 1);
            inputsOk.add(posless.toverilog());
            mini.put(posgreater.toverilog(), 1);
            inputsOk.add(posgreater.toverilog());
            inputsComp.add(posin.get(0).toverilog());
            inputsComp.add(posin.get(1).toverilog());
            
            
            return xurro;
            
        }
         
       private String comp_Shifter(Element comp, Location posout, XMLCompReader compattr)
        { 
            
            ArrayList<Location> posin; 
            String xurro = "";
            
            compattr.databits = 8;
            if(typecomp == 0)
                compattr.dimension = 40;
            else
                compattr.dimension = 60;
            compattr.shiftmode = "ll";

            compattr.ReadAttributes(comp); 
            
            /*
                <a name="width" val="9"/>
                <a name="shift" val="rr"/> ll, lr, ar, rl, rr
            */
        
            posin = new ArrayList<Location>();  
            
            if(typecomp == 0)
              {
                posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension, -10));
                posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension, 10));
              }
            else
            {
                posin.add(0, posout.movepoint(compattr.facing, -compattr.dimension, -20));
                posin.add(1, posout.movepoint(compattr.facing, -compattr.dimension, 20));
            }
           
           xurro += VerilogComponents.comp_SHIFTER(posin.get(0), posin.get(1), posout, compattr.databits, compattr.shiftmode);
           
            
            mini.put(posout.toverilog(), compattr.databits);
            inputsOk.add(posout.toverilog());
            inputsComp.add(posin.get(0).toverilog());
            inputsComp.add(posin.get(1).toverilog());
            
            
            return xurro;
            
        }                
        
        private String comp_DFlipFlop(Element comp, Location posout, XMLCompReader compattr)
        { 
            
            Location posin, posclk, posset, posclear, posenable, posoutneg; 
            String xurro = "";
            
            compattr.databits = 1;
            if(typecomp == 0)
                compattr.dimension = 40;
            else
                compattr.dimension = 60;
            //compattr.ReadAttributes(comp); 
            
            /*
               nothing
            */
            if(typecomp == 0)
            {
                posoutneg =  posout.movepoint(compattr.facing, 0, 20);
                posin =  posout.movepoint(compattr.facing, -compattr.dimension, 20);
                posclk = posout.movepoint(compattr.facing, -compattr.dimension, 0);
                posset = posout.movepoint(compattr.facing, -30, 30);
                posenable = posout.movepoint(compattr.facing, -20, 30);
                posclear = posout.movepoint(compattr.facing, -10, 30);
            }
            else
            {
                posoutneg =  posout.movepoint(compattr.facing, 0, 20);
                posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
                posclk = posout.movepoint(compattr.facing, -compattr.dimension, 10);
                posset = posout.movepoint(compattr.facing, -30, 40);
                posenable = posout.movepoint(compattr.facing, -compattr.dimension, 20);
                posclear = posout.movepoint(compattr.facing, -30, -20);
            }
            
            ini += VerilogComponents.def_REG(posout, num_reg, compattr.databits);
            
            xurro += VerilogComponents.comp_REGISTER(posin, posclk, posset, posclear, posenable, posout, posoutneg,  compattr.databits, num_reg);
            num_reg++;
            
            mini.put(posout.toverilog(), 1);
            mini.put(posoutneg.toverilog(), 1);
            inputsOk.add(posout.toverilog());
            inputsOk.add(posoutneg.toverilog());
            
            inputsComp.add(posclk.toverilog());
            inputsComp.add(posin.toverilog());
            inputsComp.add(posset.toverilog());
            inputsComp.add(posenable.toverilog());
            inputsComp.add(posclear.toverilog());
            
            
            return xurro;
            
        }                
        
        private String comp_Register(Element comp, Location posout, XMLCompReader compattr)
        { 
            
            Location posin, posclk, posclear, posenable; 
            String xurro = "";
            
            compattr.databits = 8;
            if(typecomp == 0)
                compattr.dimension = 30;
            else
                compattr.dimension = 60;
            
            compattr.ReadAttributes(comp); 
            
            /*
              <a name="width" val="9"/>
            */
            
            if(typecomp == 0)
            {
                posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
                posclk = posout.movepoint(compattr.facing, -20, 20);
                posenable = posout.movepoint(compattr.facing, -compattr.dimension, 10);
                posclear = posout.movepoint(compattr.facing, -10, 20);
            }
            else
            {
                compattr.facing = Location.parsedirection("south");
                posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
                posclk = posout.movepoint(compattr.facing, -20, -40);
                posenable = posout.movepoint(compattr.facing, -40, -40);
                posclear = posout.movepoint(compattr.facing, -40, 40);
            }
            
            ini += VerilogComponents.def_REG(posout, num_reg, compattr.databits);
            
            xurro += VerilogComponents.comp_REGISTER(posin, posclk, posclear, posenable, posout, compattr.databits, num_reg);
            num_reg++;
            
            mini.put(posout.toverilog(),  compattr.databits);
            inputsOk.add(posout.toverilog());
                
            inputsComp.add(posclk.toverilog());
            inputsComp.add(posin.toverilog());
            inputsComp.add(posenable.toverilog());
            inputsComp.add(posclear.toverilog());
            
            
            return xurro;
            
        }                
        
        
        private String comp_Counter(Element comp, Location posout, XMLCompReader compattr)
        { 
            
            Location posin, posclk, posclear, posload, poscount, poscarry; 
            String xurro = "";
            
            compattr.databits = 8;
            if(typecomp == 0)
                compattr.dimension = 30;
            else
                compattr.dimension = 60;
            compattr.shiftmode = "wrap";
            
            compattr.ReadAttributes(comp); 
            
            if(compattr.maxcount == -1)
                compattr.maxcount = (int)Math.pow(2, compattr.databits) -1;
            
            /*
                <a name="width" val="3"/>
                <a name="max" val="0x7"/>
                <a name="ongoal" val="load"/>
            */
            
            if(typecomp == 0)
            {
                poscarry =  posout.movepoint(compattr.facing, 0, 10);
                posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
                posclk = posout.movepoint(compattr.facing, -20, 20);
                poscount = posout.movepoint(compattr.facing, -compattr.dimension, 10);
                posload = posout.movepoint(compattr.facing, -compattr.dimension, -10);
                posclear = posout.movepoint(compattr.facing, -10, 20);
            }
            else
            {
                compattr.facing = Location.parsedirection("south");
                poscarry =  posout.movepoint(compattr.facing, 0, 20);
                posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
                posclk = posout.movepoint(compattr.facing, -20, -40);
                poscount = posout.movepoint(compattr.facing, -20, 40);
                posload = posout.movepoint(compattr.facing, -40, -40);
                posclear = posout.movepoint(compattr.facing, -40, 40);
            }    
            
            ini += VerilogComponents.def_REG(posout, num_reg, compattr.databits);
            
            xurro += VerilogComponents.comp_COUNTER(posin, posclk, posload, posclear, poscount, posout, poscarry, compattr.databits, compattr.maxcount, compattr.shiftmode, num_reg);
            num_reg++;
            
            mini.put(posout.toverilog(),  compattr.databits);
            inputsOk.add(posout.toverilog());
            mini.put(poscarry.toverilog(), 1);
            inputsOk.add(poscarry.toverilog());
                
            inputsComp.add(posclk.toverilog());
            inputsComp.add(posin.toverilog());
            inputsComp.add(posload.toverilog());
            inputsComp.add(posclear.toverilog());
            inputsComp.add(poscount.toverilog());
            
            
            return xurro;
            
        }                
        
        
        private String comp_RAM(Element comp, Location posout, XMLCompReader compattr)
        { 
            
            Location posin, posclk, posclear, posload, posenable, posaddress, posstore; 
            String xurro = "";
            
            compattr.databits = 8;
            compattr.widthselect = 8;
            compattr.dimension = 140;
            compattr.shiftmode = "synch";
            
            compattr.ReadAttributes(comp); 
            
            
            /*
                <a name="addrWidth" val="9"/>
                <a name="dataWidth" val="9"/>
                <a name="bus" val="separate"/>
            */
            
             
            posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
            posaddress =  posout.movepoint(compattr.facing, -compattr.dimension, 20);
            posclk = posout.movepoint(compattr.facing, -70, 40);
            posload = posout.movepoint(compattr.facing, -50, 40);
            posenable = posout.movepoint(compattr.facing,  -90, 40);
            posclear = posout.movepoint(compattr.facing, -30, 40);
            if(typecomp == 0)
                posstore = posout.movepoint(compattr.facing, -110, 40);
            else
                posstore = posout.movepoint(compattr.facing, -10, 40);
            
            if(compattr.shiftmode.equals("separate"))
            {
                ini += VerilogComponents.def_REG(posout, num_reg, compattr.databits, compattr.widthselect);
            
            
                xurro += VerilogComponents.comp_RAM(posin, posaddress, posclk, posload, posclear, posstore, posenable, posout, compattr.databits, compattr.widthselect, num_reg);
                num_reg++;
            }
            else
                xurro += "error_5_RAM_data_interface_not_supported";
            
            mini.put(posout.toverilog(),  compattr.databits);
            inputsOk.add(posout.toverilog());
         
                
            inputsComp.add(posclk.toverilog());
            inputsComp.add(posenable.toverilog());
            inputsComp.add(posin.toverilog());
            inputsComp.add(posload.toverilog());
            inputsComp.add(posclear.toverilog());
            inputsComp.add(posenable.toverilog());
            inputsComp.add(posstore.toverilog());
            
            
            return xurro;
            
        }                

        private String comp_ROM(Element comp, Location posout, XMLCompReader compattr)
        { 
            
            Location posin, posenable, posaddress; 
            String xurro = "";
            
            compattr.databits = 8;
            compattr.widthselect = 8;
            compattr.dimension = 140;
            compattr.contents = "";
            
            compattr.ReadAttributes(comp); 
            
            
            /*
                <a name="addrWidth" val="9"/>
                <a name="dataWidth" val="9"/>
                <a name="contents" val=""/>
            */
            
             
            posin =  posout.movepoint(compattr.facing, -compattr.dimension, 0);
            posaddress =  posout.movepoint(compattr.facing, -compattr.dimension, 20);      
            posenable = posout.movepoint(compattr.facing,  -90, 40);
         
  
            xurro += VerilogComponents.comp_ROM(posin, posaddress, posenable, posout, compattr.databits, compattr.widthselect, compattr.contents);
              
            
            mini.put(posout.toverilog(),  compattr.databits);
            inputsOk.add(posout.toverilog());             
         
            inputsComp.add(posenable.toverilog());
            inputsComp.add(posin.toverilog());
            inputsComp.add(posenable.toverilog());
          
            
            
            return xurro;
            
        }                

        private String splitter_get_input(Element comp)
        { 
            Location posout = Location.parse(comp.getAttribute("loc"));
            XMLCompReader compattr = new XMLCompReader();
                    
            String xurro = "";
            
            xurro += posout.toverilog();
            
            return xurro;
        }
        
        private String splitter_get_output(Element comp)
        { 
            Location posout = Location.parse(comp.getAttribute("loc"));
            XMLCompReader compattr = new XMLCompReader();
                    
            String xurro = "";
            
            compattr.databits = 2;
            compattr.input = 2;
            compattr.negatein = new int[compattr.databits];
            for(int k=0; k<compattr.databits; k++)
                compattr.negatein[k] = k;
            compattr.shiftmode = "left";
            compattr.dimension = 20;
            
            compattr.ReadAttributes(comp); 
            
            /*
              <a name="facing" val="north"/>
                <a name="fanout" val="4"/>
                <a name="incoming" val="4"/>
                <a name="appear" val="legacy"/>
                <a name="bit2" val="0"/>
            */
            
        
            
            HashMap<String,String> grid= new HashMap<String,String>();
            HashMap<Integer,Integer> repe= new HashMap<Integer,Integer>();

            int offset;
                     
            if(compattr.shiftmode.equals("legacy") || 
                    compattr.shiftmode.equals("center"))
            {
                if(compattr.facing==Location.EAST || compattr.facing==Location.WEST)
                   offset = -compattr.input/2;      
                else
                {
                    if(compattr.input%2 == 1)
                       offset = -compattr.input/2;      
                    else
                       offset = -(compattr.input/2 -1);      
                }
            }
            else if(compattr.shiftmode.equals("left") )
            {
                if(compattr.facing==Location.EAST || compattr.facing==Location.SOUTH) 
                    offset = -compattr.input;
                else
                    offset = 1; 
            }
            else
            {
                if(compattr.facing==Location.EAST || compattr.facing==Location.SOUTH) 
                    offset = 1;
                else
                    offset = -compattr.input;
            }
            
            for(int p=0;p<compattr.databits;p++)
            {
                //String input2=input;
                //int pos= Integer.valueOf(listapos[p]);
                int pos = compattr.negatein[p];
                if(pos != -1)
                {
                    if(repe.containsKey(pos))
                    {
                        int num=repe.get(pos)+1;
                        repe.put(pos, num);
                    }
                    else
                        repe.put(pos, 0);


                    Location pin = posout.movepointspl(compattr.facing, compattr.dimension,  (offset + pos) *10);

                    if(grid.containsKey(pin.toverilog()))
                        grid.put(pin.toverilog(), grid.get(pin.toverilog())+"_"+p);
                    else
                        grid.put(pin.toverilog(),p+"");
                }
            }

            Iterator itegrid= grid.keySet().iterator();
            int c=0;
            for(;itegrid.hasNext();)
            {
                String ou= (String)itegrid.next();
             
                if(c==1)
                    xurro+="/"+ou;
                else
                {
                    xurro+=ou;
                    c=1;
                }
                
            }
            
            return xurro;
        }
        
        
        private String comp_Splitter(Element comp, boolean isincoming_input)
        { 
            Location posout = Location.parse(comp.getAttribute("loc"));
            XMLCompReader compattr = new XMLCompReader();
                    
            String xurro = "";
            
            compattr.databits = 2;
            compattr.input = 2;
            compattr.negatein = new int[compattr.databits];
            for(int k=0; k<compattr.databits; k++)
                compattr.negatein[k] = k;
            compattr.shiftmode = "left";
            compattr.dimension = 20;
            
            compattr.ReadAttributes(comp); 
            
            /*
              <a name="facing" val="north"/>
                <a name="fanout" val="4"/>
                <a name="incoming" val="4"/>
                <a name="appear" val="legacy"/>
                <a name="bit2" val="0"/>
            */
            
        
            
            HashMap<String,String> grid= new HashMap<String,String>();
            HashMap<Integer,Integer> repe= new HashMap<Integer,Integer>();

            int offset;
                     
            if(compattr.shiftmode.equals("legacy") || 
                    compattr.shiftmode.equals("center"))
            {    
                if(compattr.facing==Location.EAST || compattr.facing==Location.WEST)
                   offset = -compattr.input/2;      
                else
                {
                    if(compattr.input%2 == 1)
                       offset = -compattr.input/2;      
                    else
                       offset = -(compattr.input/2 -1);      
                }
            }
            else if(compattr.shiftmode.equals("left") )
            {
                if(compattr.facing==Location.EAST || compattr.facing==Location.SOUTH) 
                    offset = -compattr.input;
                else
                    offset = 1; 
            }
            else
            {
                if(compattr.facing==Location.EAST || compattr.facing==Location.SOUTH) 
                    offset = 1;
                else
                    offset = -compattr.input;
            }
            
            for(int p=0;p<compattr.databits;p++)
            {
                Location posout2 = posout;
                //int pos= Integer.valueOf(listapos[p]);
                int pos = compattr.negatein[p];
                if(pos != -1)
                {
                    int num = 0;
                    if(repe.containsKey(pos))
                    {
                        num=repe.get(pos)+1;
                        repe.put(pos, num);
                    }
                    else
                        repe.put(pos, 0);

                    Location pin = posout.movepointspl(compattr.facing, compattr.dimension, (offset + pos) *10);

                    if(isincoming_input==false)
                    {
                        Location tmp=pin;
                        pin=posout2;
                        posout2=tmp;
                    }

                    //add input to inputComp
                    if(!inputsComp.contains(posout2.toverilog()))
                        inputsComp.add(posout2.toverilog());

                    if(isincoming_input==true)
                        xurro += VerilogComponents.comp_WIRE(posout2, p, pin, num);
                    else
                        xurro += VerilogComponents.comp_WIRE(posout2, num, pin, p);

                    if(grid.containsKey(pin.toverilog()))
                        grid.put(pin.toverilog(), grid.get(pin.toverilog())+"_"+p);
                    else
                        grid.put(pin.toverilog(),p+"");
                }
            }

            Iterator itegrid= grid.keySet().iterator();
            int c=0;
            for(;itegrid.hasNext();)
            {
                String ou= (String)itegrid.next();
             
                mini.put(ou, grid.get(ou).split("_").length);
                inputsOk.add(ou);
                
            }
            
            return xurro;
        }
        
        private String process_tunnels()
        {
            String xurro = "";
            XMLCompReader compattr = new XMLCompReader();
             
        
            
            Iterator ite= tunnels.iterator();
            for(;ite.hasNext();)//Para cada splitter
            {
                Element comp = (Element)ite.next();
                
                Location posout = Location.parse(comp.getAttribute("loc"));
            
                compattr.databits = 1;
              
                compattr.ReadAttributes(comp); 
                
                /*
                    <a name="facing" val="east"/>
                    <a name="width" val="2"/>
                    <a name="label" val="A"/>
                */
                
                if(compattr.label.matches(""))
                    return "error_1_Tunnel_" + posout.toString();//No compattr.label
                           
                if(usednames.contains(compattr.label + "_0"))
                    return "error_4_"+compattr.label;
                           
                if(!VerilogComponents.isValidLabel(compattr.label))
                    return "error_6_" + compattr.label;
                         
                if(tunnelsbylabel.containsKey(compattr.label))
                {
                    ArrayList list = tunnelsbylabel.get(compattr.label);
                    list.add(comp);
                    tunnelsbylabel.put(compattr.label, list);
                }
                else
                {
                    ArrayList list = new ArrayList();
                    list.add(comp);
                    
                    tunnelsbylabel.put(compattr.label, list);
                }
                
            }
            
         
            return "";
        }
       
        private String comp_Tunnel(Element comp)
        { 
            Location posin = Location.parse(comp.getAttribute("loc"));
            XMLCompReader compattr = new XMLCompReader();
            XMLCompReader compattr2 = new XMLCompReader();
         
                 
            String xurro = "";
            
            compattr.databits = 1;  
            compattr.ReadAttributes(comp); 
            
             /*
                    <a name="facing" val="east"/>
                    <a name="width" val="2"/>
                    <a name="label" val="A"/>
                */
            
           
           // if(tunnelsinput.containsKey(compattr.label)) 
           //     return "error_6_Tunnel_with_multiple_inputs";  
            
            if(tunnelsbylabel.containsKey(compattr.label))
            {
                //check multiple inputs
              
                
                ArrayList list = tunnelsbylabel.get(compattr.label);
                for(int i = 0; i < list.size(); i++)
                {
                    Element elt = (Element)list.get(i);
                    
                    Location posout = Location.parse(elt.getAttribute("loc"));
                             
                    if(!elt.equals(comp) /*&& !mini.containsKey(posin.toverilog())*/)
                    {
                       // tunnelsinput.put(compattr.label, elt);
                                
                        compattr2.databits = 1;  
                        compattr2.ReadAttributes(comp); 
                        
                        xurro += VerilogComponents.comp_BUFFER(posin, posout, compattr2.databits);
                          
                        mini.put(posout.toverilog(), compattr2.databits);
                        inputsOk.add(posout.toverilog());
                        
                        tunnels.remove(elt);
                     
                    }
                    
                }
            }
            
          
            
            tunnels.remove(comp);
            
            return xurro;
            
        }
        
       /* String fun_splitter(String spl, int tipo)
        {
            String xurro="";
            String[] list= spl.split("/");
            String input= list[0];
            String facing= list[1];
            int bits= Integer.valueOf(list[2]);
            int fanout= Integer.valueOf(list[3]);
            String[] listapos= list[4].split("_");
            String[] coor=input.split("_");
            int x= Integer.valueOf(coor[1]);
            int y= Integer.valueOf(coor[2]);
            Integer outx=x;
            Integer outy=y;
            Integer pos;

            HashMap<String,String> grid= new HashMap<String,String>();
            HashMap<Integer,Integer> repe= new HashMap<Integer,Integer>();

            int desp= (fanout % 2) == 0 ? 1 : 0;
            for(int p=0;p<bits;p++)
            {
                String input2=input;
                pos= Integer.valueOf(listapos[p]);
                Integer num=0;
                if(repe.containsKey(pos))
                {
                    num=repe.get(pos)+1;
                    repe.put(pos, num);
                }
                else
                    repe.put(pos, 0);

                if(facing.matches("east"))
                {
                    outx = x+2;
                    outy = y -(fanout/2)+pos;
                }
                else
                {
                    if(facing.matches("west"))
                    {
                        outx = x - 2;
                        outy = y -(fanout/2)+pos;
                    }
                    else
                    {
                        if(facing.matches("north"))
                        {
                            outx = (x +((fanout)/2)-pos)-desp;
                            outy = y-2;
                        }
                        else//south
                        {
                            outx = (x +((fanout)/2)-pos)-desp;
                            outy = y+2;
                        }
                    }
                }
                String output= "v_"+outx+"_"+outy+"_";
                //System.out.println("bit: "+p+" , pos: "+pos+" , "+output);
                if(tipo==2)
                {
                    String tmp=output;
                    output=input2;
                    input2=tmp;
                }

                if(grid.containsKey(output))
                    grid.put(output, grid.get(output)+"_"+p);
                else
                    grid.put(output,p+"");

                if(tipo==0)
                    xurro += "assign "+output+num+" = "+input2+p+";\n";
                if(tipo==2)
                    xurro += "assign "+output+p+" = "+input2+num+";\n";
            }

            Iterator itegrid= grid.keySet().iterator();
            int c=0;
            for(;itegrid.hasNext();)
            {
                String ou= (String)itegrid.next();
                if(tipo==0 || tipo==2)
                {
                    mini.put(ou, grid.get(ou).split("_").length);
                    inputsOk.add(ou);
                }
                else
                {
                    if(c==1)
                        xurro+="/"+ou;
                    else
                    {
                        xurro+=ou;
                        c=1;
                    }
                }
            }
            return xurro;
        }*/
        
    }
        


    public String initializeV(File xmlcirc, int typecomp)
    {
        WriteContext context = new WriteContext(xmlcirc, typecomp);
        return context.fromVerilogFile();
    }
    
    public String initializeV(String xmlcirc, int typecomp)
    {
        WriteContext context = new WriteContext(xmlcirc, typecomp);
        return context.fromVerilogFile();
    }
}
