package com.erubioman.verilog.metrics;

import java.io.File;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.DefaultParser;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;

import com.erubioman.Loggable;
import com.erubioman.verilog.metrics.VerilCircMetrics;

public class ConsoleLaunch implements Loggable {

	public void addLog(String text) {
		System.out.print(text);
	}

	public boolean execute(String[] args) {
		boolean result = false;
		Options options = new Options();
		options.addOption(
				Option.builder("c").longOpt("csv").hasArg().desc("fitxer CSV de descripció d'exercicis").build());
		options.addOption(
				Option.builder("n").longOpt("number").hasArg().desc("nombre d'exercici (expressió regular)").build());
		options.addOption(Option.builder("o").longOpt("output").hasArg().desc("fitxer CSV de resultats").build());

		try {
			// parse the command line arguments
			CommandLineParser parser = new DefaultParser();
			CommandLine line;
			line = parser.parse(options, args);
			String exercises[] = line.getArgs();
			if (exercises.length > 0) {
				String outputFile = line.getOptionValue("output");
				String csv = line.getOptionValue("csv");
				result = true;
				new VerilCircMetrics(this).analyzeFiles((csv != null ? new File(csv) : null), exercises,
						new File(outputFile != null ? outputFile : "VerilCircMetrics.csv"),
						line.getOptionValue("number"));
			}
		} catch (ParseException e) {
			addLog("Excepció en el parsejat: " + e.getMessage() + "\n");
		}
		return result;
	}
}
